SEM_POST(3)

NAME
sem_post - increment (unlock) a semaphore

LIBRARY
libc_r

SYNOPSIS
#include <semaphore.h>
int
sem_post(sem_t *sem);

DESCRIPTION
The sem_post() function increments (unlocks) the semaphore pointed to by sem. If there are threads blocked on the semaphore when sem_post() is called, then the highest priority thread that has been blocked the longest on the semaphore will be allowed to return from sem_wait().

RETURN VALUES
If successful, sem_post() returns 0. Otherwise, -1 is returned and errno is set to indicate the type of error.

ERRORS
sem_post() will fail if:

[EINVAL]
    sem points to an invalid semaphore.

SEE ALSO
sem_wait(3), sem_trywait(3)

STANDARDS
sem_post() conforms to ISO/IEC 9945-1 ANSI/IEEE (“POSIX”) Std 1003.1 1996 Edition.